<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Drink</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="drink-code">Mã nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-drink-code" name="drinkcodes" placeholder="Drink code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="name">Tên nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-drink-name" name="name" placeholder="Name" class="form-control">
		</div>
	  </div>
		<div class="row form-group">
			<div class="col-sm-3">
				<label for="price">Đơn giá</label>
			</div>
			<div class="col-sm-9">
				<input type="number" id="input-price" name="note" placeholder="price" class="form-control">
			</div>
			</div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-2">
		  <button id="update_data" class="btn btn-info">Update Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="create_data" class="btn btn-success">Create Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="delete_data" class="btn btn-danger">Delete Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="delete_all_data" class="btn btn-danger">Delete All Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã nước uống</th>
        <th>Tên nước uống</th>
				<th>Đơn giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
	"use strict";
	const gBASE_URL = "http://localhost:8080/drinks";
	var gObjectDrink = [];
	var vId = 0;
	var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maNuocUong"},
				{"data":"tenNuocUong"},
				{"data":"price"},
				{"data":"ghiChu"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
			]
		});
	$(document).ready(function(){
		callApiAllDrinks();
		
		$('#user-table').on('click', 'tr', function(){
        vId = $(this).find('td:first').text();
        loadDrinkDataById(vId);
    });

		$('#update_data').on('click', function(){
				var vObj ={
					maNuocUong:"",
					tenNuocUong:"",
					price: 0,
					ghiChu:"",
					ngayTao:"",
					ngayCapNhat:"",
				}
				getDataForm(vObj);
        getUpdateDataApi(vId, vObj);
				resetForm();
    });
		
		$('#create_data').on('click', function(){
				var vObj ={
					maNuocUong:"",
					tenNuocUong:"",
					price: 0,
					ghiChu:"",
					ngayTao:"",
					ngayCapNhat:"",
				}
				getDataForm(vObj);
				var vIsValidate = validateData(vObj);
				if(vIsValidate){
					getCreateDataApi(vObj);
					resetForm();
				}
    });
		
		$('#delete_data').on('click', function(){
			deleteDrinkById(vId);
			resetForm();
    });
	
		$('#delete_all_data').on('click', function(){
			deleteAllDrinkById();
    });
	});

	function callApiAllDrinks(){
		$.ajax({
			url: gBASE_URL,
			type: "GET",
			dataType: "json",
			success: function(res){
				gObjectDrink= res;
				DisplayOrderToTable(res);
			},
			error: function(err){
				console.log(err.response);
			}
		});
	}
	function loadDrinkDataById(id) {
			fetch(`http://localhost:8080/drinks/${id}`)
			.then(response => response.json())
			.then(data => {
				// Hiển thị thông tin Drink lên form
				$('#input-drink-code').val(data.maNuocUong);
				$('#input-drink-name').val(data.tenNuocUong);
				$('#input-price').val(data.price);
				$('#input-note').val(data.ghiChu);
				$('#input-createDate').val(data.ngayTao);
				$('#input-updateDate').val(data.ngayCapNhat);
			})
			.catch(error => console.error(error));
		}
	function getUpdateDataApi(pId, pObject) {
			$.ajax({
				url: gBASE_URL+ "/" + pId,
				type: "PUT",
				contentType: "application/json;charset=UTF-8",
    		data: JSON.stringify(pObject),
				success: function(res){
					callApiAllDrinks();
				},
				error: function(err){
					console.log(err.responseText);
				}
			});
		}
	function getDataForm(paramObj){
		paramObj.maNuocUong = $('#input-drink-code').val();
		paramObj.tenNuocUong = $('#input-drink-name').val();
		paramObj.price = $('#input-price').val();
		paramObj.ghiChu = $('#input-note').val();
		paramObj.ngayTao = $('#input-createDate').val();
		paramObj.ngayCapNhat = $('#input-updateDate').val();
	}
	function DisplayOrderToTable(paramData) {
			"use strict";
			$("#user-table").DataTable().clear(); // xóa dữ liệu
			$("#user-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
			$("#user-table").DataTable().draw(); //vẽ lại bảng
		}
	function getCreateDataApi(pObject) {
		$.ajax({
			url: gBASE_URL,
			type: "POST",
			contentType: "application/json;charset=UTF-8",
			data: JSON.stringify(pObject),
			success: function(res){
				callApiAllDrinks();
			},
			error: function(err){
				console.log(err.responseText);
			}
		});
	}
	function validateData(paramObj){
		if(paramObj.maNuocUong == 0){
			alert("Bạn chưa điền mã Drink!");
    	return false;
		}
		if(paramObj.tenNuocUong == 0){
			alert("Bạn chưa điền phần trăm giảm giá!");
    	return false;
		}
		if(paramObj.price == ""){
			alert("Bạn chưa điền ghi chú!");
    	return false;
		}
		return true;
	}
	function resetForm(){
		$('#input-drink-code').val("");
		$('#input-drink-name').val("");
		$('#input-price').val("");
		$('#input-note').val("");
		$('#input-createDate').val("");
		$('#input-updateDate').val("");
	}
	function deleteDrinkById(pId) {
		$.ajax({
			url: gBASE_URL + "/" + pId,
			type: "DELETE",
			async: false,
			success: function (paramOrderRes) {
				callApiAllDrinks();
			},
			error: function (paramErr) {
				console.log(paramErr.status);
			},
		});
	}
	function deleteAllDrinkById() {
		$.ajax({
			url: gBASE_URL,
			type: "DELETE",
			async: false,
			success: function (paramOrderRes) {
				callApiAllDrinks();
			},
			error: function (paramErr) {
				console.log(paramErr.status);
			},
		});
	}
</script>
</body>
</html>
